#ifndef EMAP_H
#define EMAP_H
#include "config.h"
#include "layout.h"
#include "obj.h"

typedef enum {
	eb_meat,          // ʤɤ٤ʪ¸
	eb_vegetable,          // ʤɤ٤ʪ¸
    eb_gondin,        // Gondinμ
    eb_sign,          // 
	eb_weight,        // åФ

	// OwnerѤ뤿ᡢǽˤޤȤƤ

	eb_block_left,  // ΰ֤ꤽؤΰưػߤ
	eb_block_right, //   ɤʤɤμϤꤹ
    eb_block_up,
    eb_block_down,
    eb_exclude_left,  // 㳲ʪ餽˲ФȤ
    eb_exclude_right, 
    eb_exclude_up,
    eb_exclude_down,

	eb_push_left,   // ưȤ(ذưưξʤ)
    eb_push_right,  // ưȤ(ذưưξʤ)
    eb_push_up,     // 䲼ưȤ(岼ذưΥեȤʤ)
    eb_push_down,   //   ºݤˤexclude_upϤѤ뤿push_left/rightΤ褦
	                //   ̤ȯʤ׻ξ岼ȽΤ
					//   եȾˤ°ꤹ롣

    eb_push_leftdown, // ưȤ롣ѡ
    eb_push_rightdown,// ǽʤ̰Τᡢleft+downǤѤǤʤ
	eb_blast_left,
	eb_blast_right,

	eb_goal,          // ɥ
    eb_eat,           // Gondinμ¤򿩤٤褦Ȥ륭¸(req_queueȤä!!ѻ?)
    eb_shock,         // ׷(ҥɤ˲롢եȤѥοʹȯ)
    eb_flame,         // 
    eb_pierce,        // 

    /*
    eb_block,       // ɤʤɤ٤ƤΤΤ̲Բǽʾ㳲ʪ
    */
    eb_end
} effect_bit_t;

typedef unsigned int emap_e_t;

#define NextEMap (-(~(-current_emap)))

// emapå˰ääɸ򥨥󥳡ɤCheckValȤ
// Ѵޥ
// ޥå׼Ϥɤ顢(0, 0)ä뤳ȤϤʤ
#define Pos2CheckVal(x, y) (((y)<<8) + (x))
#define CheckVal2PosX(v) (v & 0xff)
#define CheckVal2PosY(v) (((v)>>8) & 0xff)
#define ReturnCheckEMapPos(x, y, eb) \
	if (CheckEMap(x, y, eb)){return Pos2CheckVal(x, y);}
//{assert(GetEMapOwner(x, y, eb) != NULL);      

// emapޥ
#define SetEMapStatic(x, y, eb) \
    (emap_static[y][x] |= (1 << (eb)))
#define ResetEMapStatic(x, y, eb) \
    (emap_static[y][x] &= ~(1 << (eb)))
#define SetEMap(x, y, eb) \
    (emap[NextEMap][y][x] |= (1 << (eb)))
#define ResetEMap(x, y, eb) \
    (emap[NextEMap][y][x] &= ~(1 << (eb)))
#define CheckEMap(x, y, eb) \
    (emap[current_emap][y][x] & (1 << (eb)))
#define SetEMapOwnerStatic(x, y, eb, obj) \
    (emap_owner_static[eb][y][x] = obj)
#define ResetEMapOwnerStatic(x, y, eb) \
    (emap_owner_static[eb][y][x] = NULL)
#define SetEMapOwner(x, y, eb, obj) \
	(emap_owner[NextEMap][eb][y][x] = obj)
#define ResetEMapOwner(x, y, eb) \
	(emap_owner[NextEMap][eb][y][x] = NULL)
// OwnerΥ٤㤤Τ
// emap_owner_static󥳥ԡˡemap_ownerǸĤʤȤ˹Ԥ
#define GetEMapOwner(x, y, eb) \
	(emap_owner[current_emap][eb][y][x] ? \
     emap_owner[current_emap][eb][y][x] : emap_owner_static[eb][y][x])

//#define SetEMapStaticBox(ltx, lty, width, height, sb)         
//    (set_emap_static_box(ltx, lty, width, height, (eb_##sb)))
//#define SetEMapBox(ltx, lty, width, height, sb)       
//    (set_emap_box(ltx, lty, width, height, (eb_##sb)))
//#define ResetEMapBox(ltx, lty, width, height, sb)         
//    (reset_emap_box(ltx, lty, width, height, (eb_##sb)))

//#define SetEMapOwnerBox(ltx, lty, width, height, eb, obj)     
//	(set_emap_owner_box(ltx, lty, width, height, eb, obj))

//#define GetEMapElem(x, y)                     
//    (emap[current_emap][y][x])
//#define CheckEMapElem(e, eb)                 
//    ((e) & (1 << (eb)))

//#define check_emap(x, y, eb)                  
//	(emap[current_emap][y][x] & (1 << (eb)))
//#define check_emap_element(e, eb)             
//    ((e) & (1 << (eb)))

//#define CheckEMapDir(eb, dir, obj)            
//    (check_emap_dir(eb, dir, obj))
//#define CheckEMapAllCorner(eb, obj)           
//    (check_emap_all_corner(eb, obj))
//#define CheckEMapAnyCorner(eb, obj)           
//    (check_emap_any_corner(eb, obj))
//#define CheckEMapAnyRim(eb, obj)             
//    (check_emap_any_rim(eb, obj))

#define Ltx(obj) ((obj)->x)
#define Lty(obj) ((obj)->y)
#define Rtx(obj) ((obj)->x+(obj)->width-1)
#define Rty(obj) ((obj)->y)
#define Lbx(obj) ((obj)->x)
#define Lby(obj) ((obj)->y+(obj)->height-1)
#define Rbx(obj) ((obj)->x+(obj)->width-1)
#define Rby(obj) ((obj)->y+(obj)->height-1)

extern emap_e_t emap_static[MAP_HEIGHT][MAP_WIDTH];
extern emap_e_t emap[2][MAP_HEIGHT][MAP_WIDTH];
extern obj_t *emap_owner[2][32][MAP_HEIGHT][MAP_WIDTH];
extern obj_t *emap_owner_static[32][MAP_HEIGHT][MAP_WIDTH];
extern int current_emap;

void emap_init(void);
void setup_emap(void);
void clear_emap_owner(void);
void clear_emap(void);
void switch_current_emap(void);
void cp_or_static_emap(void);
void copy_emap(void);
void cp_static_emap(void);
void set_emap_static_box(int ltx, int lty, int width, int height,
                         effect_bit_t bit);
void set_emap_box(int ltx, int lty, int width, int height, effect_bit_t bit);
void reset_emap_box(int ltx, int lty, int width, int height, effect_bit_t bit);
void set_emap_owner_box(int ltx, int lty, int width, int height, effect_bit_t eb, obj_t *obj);
void set_emap_owner_static_box(int ltx, int lty, int width, int height, effect_bit_t eb, obj_t *obj);

void set_emap_static_blockbox(int ltx, int lty, int width, int height);
void reset_emap_static_blockbox(int ltx, int lty, int width, int height);
void set_emap_blockbox(int ltx, int lty, int width, int height);

int check_emap_box_any(int ltx, int lty, int width, int height, effect_bit_t eb);
int check_emap_obj_any(obj_t *obj, effect_bit_t eb);
int check_emap_pos_box_any(int ltx, int lty, int width, int height, effect_bit_t eb);
int check_emap_pos_obj_any(obj_t *obj, effect_bit_t eb);

int check_emap_box_any_corner(int ltx, int lty, int width, int height, effect_bit_t eb);
int check_emap_obj_any_corner(obj_t *obj, effect_bit_t eb);
int check_emap_pos_box_any_corner(int ltx, int lty, int width, int height, effect_bit_t eb);
int check_emap_pos_obj_any_corner(obj_t *obj, effect_bit_t eb);

int check_emap_box_all_corner(int ltx, int lty, int width, int height, effect_bit_t eb);
int check_emap_obj_all_corner(obj_t *obj, effect_bit_t eb);

int check_emap_box_any_left(int ltx, int lty, int width, int height, effect_bit_t eb);
int check_emap_box_any_right(int ltx, int lty, int width, int height, effect_bit_t eb);
int check_emap_box_any_up(int ltx, int lty, int width, int height, effect_bit_t eb);
int check_emap_box_any_down(int ltx, int lty, int width, int height, effect_bit_t eb);
int check_emap_obj_any_left(obj_t *obj, effect_bit_t eb);
int check_emap_obj_any_right(obj_t *obj, effect_bit_t eb);
int check_emap_obj_any_up(obj_t *obj, effect_bit_t eb);
int check_emap_obj_any_down(obj_t *obj, effect_bit_t eb);

int check_emap_box_any_rim(int ltx, int lty, int width, int height, effect_bit_t eb);
int check_emap_obj_any_rim(obj_t *obj, effect_bit_t eb);


int check_emap_dir(effect_bit_t eb, dir_t dir, obj_t *obj);
int check_emap_left(effect_bit_t eb, obj_t *obj);
int check_emap_right(effect_bit_t eb, obj_t *obj);
int check_emap_up(effect_bit_t eb, obj_t *obj);
int check_emap_down(effect_bit_t eb, obj_t *obj);
int check_emap_any_rim(effect_bit_t eb, obj_t *obj);
#endif

