#ifndef OBJ_H
#define OBJ_H
#include "config.h"
#include "uty.h"
#include "param.h"

typedef enum {
    oc_begin = 0,
    oc_static = 0,
    oc_hard_dynamic,
    oc_soft_dynamic,
    oc_end
} obj_class_t;

typedef enum {
    os_none,     // ̾¸ 
    os_eating,   // ٤Ƥ
    os_digesting,// 𤬾ò档
    os_vomitting,// 𤬹ǤФ
	os_blast, // Gagga
	os_head_high,    // μ岼
	os_head_low,
	os_breath_high, // ι
	os_breath_low,
    // ޤǤIsAlive
	os_is_alive_end,	
	
	os_retry,    // Cheeꤹȥơꥹ
	os_quit,     // cheeꤹȥơ쥯Ȥ
    os_ghost,    // Cheeͩ
	os_gameover, // ४С
	os_exit,
	os_clear, // Cheeơꥢ
	os_show_result, // ơꥢåɽ
    os_smash_h1, // ʿ1ñ٤줿֡ƥåפbang˰ܹ
    os_smash_h2, // ʿ2ñ٤줿֡ƥåפbang˰ܹ
    os_smash_v1, // ľ1ñ٤줿֡ƥåפbang˰ܹ
    os_smash_v2, // ʿ2ñ٤줿֡ƥåפbang˰ܹ
    os_bang,     // եåܸʣ뤬ƥåפǻ˴
    os_pierced,  // ȤǤ˻ɤä
    os_burned,   // ꡦХꥢǾǤ
    os_eaten,    // ٤줿ν()ϥ֥Ȱ¸
    os_digested, // ٤Ƥޤò档
    os_cancel,   // ưߡȤꤢῩߤ˻Ȥ
    os_req_on,
    os_req_off,
    os_on,
    os_off,
	os_weighted_on,
	os_weighted_off,
    os_nonweighted_on,
    os_nonweighted_on_int,
    os_nonweighted_off,
    os_goal_req_open, // 򳫤Ϥ
	os_goal_opening,
	os_goal_opened,
	os_goal_closing,
	os_gondin_eaten,
} obj_state_t;

typedef enum {
//    at_immune_ojigiri, // ˿٤ʤ
	at_meat,           // ưʪ(Ῡо)
	at_vegetable,      // ʪ(ȿʤäϲ)

    at_rooted,         // 򲼤Ƥ(exclude줿¨) 
	at_immune_pierce,   // ̵
} attr_bit_t;

#define  SetAttr(obj, at)                        \
     ((obj)->attr |= (1 << (at)))
#define CheckAttr(obj, at)                 \
     ((obj)->attr & (1 << (at)))

typedef enum {
    ot_begin = 0, ot_none = 0,

	ot_gondin,   // ǥμ

	ot_hatopo,   // ϤȤ
	ot_gagga,    // ä
	ot_yaarashi, // 
    ot_ojigiri,  // 
	ot_sue,      // 
    ot_chee,     // ץ쥤䡼
	
	ot_blank,    // 
    ot_wall,     // ˲ǽưʤ
    ot_fwall,    // ˲ǽ
	ot_iwall,    // ɹ
	ot_barrier,  // Хꥢ
	ot_goal,
    ot_slope_l,  // ̺
    ot_slope_r,
    ot_stairs_l,  // ʺ
    ot_stairs_r,
	ot_sign,




	ot_lift,     // ١
	ot_mswitch,  // ⡼󥿥ꥹå(äƤ֤ON)
	ot_aswitch,  // 륿͡ȥå(٤ON/OFFڤ괹)

    ot_nya,      // 
	ot_punch,    // 
	ot_flame,

    ot_sting,    // ˲ǽưǽ
                 // ΥפcreateؿƤ֤ȤΤ߻Ȥ졢
                 //   ºݤˤϻꤷ˱ʲΤ줫
                 //   mapեˤñ쥷ܥ+ǵҤ
                 //   Ƚ꤬ۤʤ
                 //   ¹Ϥ줾̥פȤΨ褤Ǥ롣
    ot_sting_l,  // 
    ot_sting_r,  // 
    ot_sting_u,  // 
    ot_sting_d,  // 



    ot_mvfloor,  // ư
    ot_end
} obj_type_t;


typedef struct {
    int move_x;         // ʿΰư
    int inertia_x;      // եȤδ(׳ϻjump_x)
    int inertia_y;      // եȤδ(׳ϻjump_y)
                        // եȤδϻeb_push_leftʤɤǷޤ뤬
                        //   ˤϥեȤƶʤΤǡ
                        //   δͤȤ϶̤ɬפ
    int jump_x;         // ׻οʿɲðư(եȤΥ֡ʬ)
    int jump_y;         // ׻ξ岼ɲðư(եȤΥ֡ʬ)
    int float_time;     // ڶ(徺+ʿ)֥
	int jump_y_limit;   // פǤã־
    int is_landed;      // ϤƤ1
    int is_walking;     // ⤤Ƥ1
    int is_sliding;     // Ƥʤ1
    int is_stunned;     // ưǽ֤ʤ1
	int blast_x;
} obj_creature_t;

#define MoveX(obj) ((obj)->u.creature.move_x)
#define IsStunned(obj) ((obj)->u.creature.is_stunned)
#define IsLanded(obj) ((obj)->u.creature.is_landed)

typedef struct {
	int no; // signåֹ
} obj_sign_t;

typedef struct {
    int is_reverse; // 1ʤƧǤȤOFF
} obj_mswitch_t;

typedef struct {
	int lenctr;
} obj_flame_t;

/*
typedef struct {
} obj_chee_t;

typedef struct {
} obj_hatopo_t;

typedef struct {
    int width;       // ʿ礭
    int xmin, xmax;  // ʿ(obj->x)κǾ
} obj_mvfloor_t;

*/

/*
typedef struct {
    int width;       // ʿ礭  
    int ymin, ymax;  // ľ(obj->y)κǾ
} obj_lift_t;
*/

typedef struct obj_s{
    obj_class_t class;
    obj_type_t type;
    dir_t dir;
    int x, y;
    int width;
    int height;
	struct obj_s *link;  // !! Ū? 
    int motion;         // ưѥΥǥå
    obj_state_t state; // ˴٤Ƥ롢ʤɤξ
    int ctr;              // ʣƥåפstateѤΥ
    struct obj_s *prev, *next;
    int attr;
    union {
        obj_creature_t creature;
		obj_sign_t sign;
		obj_mswitch_t mswitch;
		obj_flame_t flame;
//		obj_nya_t nya;
        //        obj_mvfloor_t mvfloor;
        //        obj_lift_t lift;
    } u;
} obj_t;

typedef struct {
    void (*create)(obj_t *, int, int, dir_t);
    int  (*act)(obj_t *);  // Υ֥Ȥ0֤
    int (*draw)(obj_t *);
    int (*post_draw)(obj_t *);
    int (*set_action)(obj_t *);
    void (*set_motion)(obj_t *);
	void (*set_emap)(obj_t *);
} obj_funcs_t;

typedef struct {
    obj_type_t type;
    obj_class_t oclass;
    obj_funcs_t funcs;
} obj_info_t;

// ¾Υ֥Ȥstateѹꥯȥ塼
// ľstateѹȡ׵¦ѹ¦ν˰¸
// ܥߥ󥰤Τǡ
// ü塼ˤǡƥå˰
typedef struct {
    obj_t *dist;
    obj_t *src;
    obj_state_t state;
} state_req_entry_t;

#define State(obj) ((obj)->state)
#define Ctr(obj) ((obj)->ctr)
#define SetState(obj, st)                    \
    (((obj)->state = st),                    \
     ((obj)->ctr = 0))
#define SetCtr(obj, val)                        \
    ((obj)->ctr = val)
#define IncCtr(obj) ((obj)->ctr ++)
#define IsAlive(obj)                         \
    (State(obj) >= os_none &&                \
     State(obj) < os_is_alive_end)
#define IsEating(obj) (State(obj) == os_eating)

#define ReqState(dist, src, st)                  \
    (push_obj_req(dist, src, st))





void obj_init(void);
void setup_obj_list(void);
obj_t *create_obj_grid(obj_type_t type, int x, int y, dir_t dir);
obj_t *create_obj(obj_type_t type, int x, int y, dir_t dir);
void delete_obj(obj_t *obj);

obj_t *create_sign_grid(obj_type_t type, int x, int y, int link_no);


void forall_obj(int(*f)(obj_t *), obj_class_t class);
//void act_obj_list(void);
int act_obj(obj_t *obj);
void draw_obj_list(void);
int draw_obj(obj_t *obj);
int post_draw_obj(obj_t *obj);

void clear_obj_req_queue(void);
void push_obj_req(obj_t *dist, obj_t *src, obj_state_t state);
void apply_all_req(void);

void create_chee(obj_t *obj, int ox, int oy, dir_t dir);
void set_chee(obj_t *obj);
obj_t *get_chee(void);
void create_gondin(obj_t *obj, int ox, int oy, dir_t dir);
void create_hatopo(obj_t *obj, int ox, int oy, dir_t dir);
void create_yaarashi(obj_t *obj, int ox, int oy, dir_t dir);
void create_gagga(obj_t *obj, int ox, int oy, dir_t dir);
void create_ojigiri(obj_t *obj, int ox, int oy, dir_t dir);
void create_sue(obj_t *obj, int ox, int oy, dir_t dir);
void create_flame(obj_t *obj, int ox, int oy, dir_t dir);
void create_nya(obj_t *obj, int ox, int oy, dir_t dir);
void create_punch(obj_t *obj, int ox, int oy, dir_t dir);
void create_wall(obj_t *obj, int ox, int oy, dir_t dir);
void create_goal(obj_t *obj, int ox, int oy, dir_t dir);
void create_sign(obj_t *obj, int ox, int oy, dir_t dir);
void create_sting(obj_t *obj, int ox, int oy, dir_t dir);
void create_fwall(obj_t *obj, int ox, int oy, dir_t dir);
void create_iwall(obj_t *obj, int ox, int oy, dir_t dir);
void create_barrier(obj_t *obj, int ox, int oy, dir_t dir);
void create_slope_l(obj_t *obj, int ox, int oy, dir_t dir);
void create_slope_r(obj_t *obj, int ox, int oy, dir_t dir);
void create_stairs_l(obj_t *obj, int ox, int oy, dir_t dir);
void create_stairs_r(obj_t *obj, int ox, int oy, dir_t dir);
//void create_mvfloor(obj_t *obj, int ox, int oy, dir_t dir);
//void set_grid_range_mvfloor(obj_t *obj, int xmin, int xmax);
//void set_grid_width_mvfloor(obj_t *obj, int width);
void create_lift(obj_t *obj, int ox, int oy, dir_t dir);
void create_mswitch(obj_t *obj, int ox, int oy, dir_t dir);
void create_aswitch(obj_t *obj, int ox, int oy, dir_t dir);
void set_grid_width_static(obj_t *obj, int width);
void set_grid_width_dynamic(obj_t *obj, int width);
void set_grid_height_dynamic(obj_t *obj, int height);

obj_state_t exclude_obj(obj_t *obj);
int move_obj_horizontal(obj_t *obj, int xoffset);
int walk_obj(obj_t *obj, int xoffset);
int push_horizontal(obj_t *obj);
int push_diagonal(obj_t *obj);
int blast_horizontal(obj_t *obj);

int act_creature(obj_t *obj);
int act_chee(obj_t *obj);
int set_action_gondin(obj_t *obj);
void set_motion_gondin(obj_t *obj);
void set_emap_gondin(obj_t *obj);
int set_action_hatopo(obj_t *obj);
void set_motion_hatopo(obj_t *obj);
int set_action_yaarashi(obj_t *obj);
void set_motion_yaarashi(obj_t *obj);
void set_emap_yaarashi(obj_t *obj);
int set_action_ojigiri(obj_t *obj);
void set_motion_ojigiri(obj_t *obj);
int set_action_gagga(obj_t *obj);
void set_motion_gagga(obj_t *obj);
void set_emap_gagga(obj_t *obj);
int set_action_nya(obj_t *obj);
void set_motion_nya(obj_t *obj);
int set_action_sue(obj_t *obj);
void set_motion_sue(obj_t *obj);
int act_punch(obj_t *obj);
//void move_mvfloor(obj_t *obj);
int act_lift(obj_t *obj);
int act_goal(obj_t *obj);
int act_fwall(obj_t *obj);
int act_iwall(obj_t *obj);
int act_barrier(obj_t *obj);
int act_mswitch(obj_t *obj);
void on_aswitch(obj_t *obj);
int act_aswitch(obj_t *obj);
int act_flame(obj_t *obj);


#endif
