#include <stdio.h>
#include <EzGraph.h>
#include "config.h"
#include "main.h"
#include "stage_info.h"
#include "stage_info_draw.h"

void stage_info_init(void){
}

void setup_stage_info(void){
    EzSetKeyHandler(stage_info_keyh);
    EzSetKeyReleaseHandler(stage_info_key_releaseh);
    EzSetTimerHandler(stage_info_timerh, GAME_SPEED);
    setup_stage_info_draw();
    printf("setup stage info\n");
}

void stage_info_keyh(int key){
    switch (key){
    default:
        break;
    }
}

void stage_info_key_releaseh(int key){
    switch (key){
    case 'q':
	case 27:
    case ' ':
    case EZ_Return:
        set_main_state(ms_select_stage);
        break;
    default:
        break;
    }
}

void stage_info_timerh(void){
    draw_stage_info();
}



